/*
 * generated by Xtext 2.29.0
 */
package org.eclipse.papyrus.robotics.xtext.datatypes.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.papyrus.uml.alf.services.CommonGrammarAccess;
import org.eclipse.papyrus.uml.textedit.common.xtext.services.UmlCommonGrammarAccess;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.EnumRule;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class DTMLGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class ModelElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.Model");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cXDataTypeParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cXAssignmentParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		private final RuleCall cXEnumerationParserRuleCall_2 = (RuleCall)cAlternatives.eContents().get(2);
		
		//Model:
		//    XDataType | XAssignment | XEnumeration
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//XDataType | XAssignment | XEnumeration
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//XDataType
		public RuleCall getXDataTypeParserRuleCall_0() { return cXDataTypeParserRuleCall_0; }
		
		//XAssignment
		public RuleCall getXAssignmentParserRuleCall_1() { return cXAssignmentParserRuleCall_1; }
		
		//XEnumeration
		public RuleCall getXEnumerationParserRuleCall_2() { return cXEnumerationParserRuleCall_2; }
	}
	public class XDataTypeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.XDataType");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cDTKeyParserRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cAttributesAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cAttributesPropertyParserRuleCall_3_0 = (RuleCall)cAttributesAssignment_3.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_4 = (Keyword)cGroup.eContents().get(4);
		
		//XDataType:
		//    DTKey name = ID '{'
		//        (attributes += Property)*
		//    '}'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//DTKey name = ID '{'
		//    (attributes += Property)*
		//'}'
		public Group getGroup() { return cGroup; }
		
		//DTKey
		public RuleCall getDTKeyParserRuleCall_0() { return cDTKeyParserRuleCall_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//(attributes += Property)*
		public Assignment getAttributesAssignment_3() { return cAttributesAssignment_3; }
		
		//Property
		public RuleCall getAttributesPropertyParserRuleCall_3_0() { return cAttributesPropertyParserRuleCall_3_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_4() { return cRightCurlyBracketKeyword_4; }
	}
	public class DTKeyElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.DTKey");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Keyword cDataTypeKeyword_0 = (Keyword)cAlternatives.eContents().get(0);
		private final Keyword cCommObjectKeyword_1 = (Keyword)cAlternatives.eContents().get(1);
		
		//DTKey:
		//    'DataType' | 'CommObject'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'DataType' | 'CommObject'
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//'DataType'
		public Keyword getDataTypeKeyword_0() { return cDataTypeKeyword_0; }
		
		//'CommObject'
		public Keyword getCommObjectKeyword_1() { return cCommObjectKeyword_1; }
	}
	public class PropertyElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.Property");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cAttributeKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Keyword cColonKeyword_2_0 = (Keyword)cGroup_2.eContents().get(0);
		private final Alternatives cAlternatives_2_1 = (Alternatives)cGroup_2.eContents().get(1);
		private final Assignment cTypeAssignment_2_1_0 = (Assignment)cAlternatives_2_1.eContents().get(0);
		private final RuleCall cTypeTypeRuleParserRuleCall_2_1_0_0 = (RuleCall)cTypeAssignment_2_1_0.eContents().get(0);
		private final Assignment cTypeUndefinedAssignment_2_1_1 = (Assignment)cAlternatives_2_1.eContents().get(1);
		private final Keyword cTypeUndefinedUndefinedKeyword_2_1_1_0 = (Keyword)cTypeUndefinedAssignment_2_1_1.eContents().get(0);
		private final Assignment cMultiplicityAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cMultiplicityMultiplicityRuleParserRuleCall_3_0 = (RuleCall)cMultiplicityAssignment_3.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cEqualsSignKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cValueAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cValueValueParserRuleCall_4_1_0 = (RuleCall)cValueAssignment_4_1.eContents().get(0);
		private final Assignment cCommentAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cCommentVSL_COMMENTTerminalRuleCall_5_0 = (RuleCall)cCommentAssignment_5.eContents().get(0);
		
		//Property:
		//    'attribute' name=ID (':' (type=TypeRule | typeUndefined?="<Undefined>"))?
		//    (multiplicity = MultiplicityRule)?
		//    ('=' value = Value)?
		//    (comment = VSL_COMMENT)?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'attribute' name=ID (':' (type=TypeRule | typeUndefined?="<Undefined>"))?
		//(multiplicity = MultiplicityRule)?
		//('=' value = Value)?
		//(comment = VSL_COMMENT)?
		public Group getGroup() { return cGroup; }
		
		//'attribute'
		public Keyword getAttributeKeyword_0() { return cAttributeKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//(':' (type=TypeRule | typeUndefined?="<Undefined>"))?
		public Group getGroup_2() { return cGroup_2; }
		
		//':'
		public Keyword getColonKeyword_2_0() { return cColonKeyword_2_0; }
		
		//(type=TypeRule | typeUndefined?="<Undefined>")
		public Alternatives getAlternatives_2_1() { return cAlternatives_2_1; }
		
		//type=TypeRule
		public Assignment getTypeAssignment_2_1_0() { return cTypeAssignment_2_1_0; }
		
		//TypeRule
		public RuleCall getTypeTypeRuleParserRuleCall_2_1_0_0() { return cTypeTypeRuleParserRuleCall_2_1_0_0; }
		
		//typeUndefined?="<Undefined>"
		public Assignment getTypeUndefinedAssignment_2_1_1() { return cTypeUndefinedAssignment_2_1_1; }
		
		//"<Undefined>"
		public Keyword getTypeUndefinedUndefinedKeyword_2_1_1_0() { return cTypeUndefinedUndefinedKeyword_2_1_1_0; }
		
		//(multiplicity = MultiplicityRule)?
		public Assignment getMultiplicityAssignment_3() { return cMultiplicityAssignment_3; }
		
		//MultiplicityRule
		public RuleCall getMultiplicityMultiplicityRuleParserRuleCall_3_0() { return cMultiplicityMultiplicityRuleParserRuleCall_3_0; }
		
		//('=' value = Value)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'='
		public Keyword getEqualsSignKeyword_4_0() { return cEqualsSignKeyword_4_0; }
		
		//value = Value
		public Assignment getValueAssignment_4_1() { return cValueAssignment_4_1; }
		
		//Value
		public RuleCall getValueValueParserRuleCall_4_1_0() { return cValueValueParserRuleCall_4_1_0; }
		
		//(comment = VSL_COMMENT)?
		public Assignment getCommentAssignment_5() { return cCommentAssignment_5; }
		
		//VSL_COMMENT
		public RuleCall getCommentVSL_COMMENTTerminalRuleCall_5_0() { return cCommentVSL_COMMENTTerminalRuleCall_5_0; }
	}
	public class XAssignmentElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.XAssignment");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameIDTerminalRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Keyword cEqualsSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cExpressionAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cExpressionExpressionStringParserRuleCall_2_0 = (RuleCall)cExpressionAssignment_2.eContents().get(0);
		private final Keyword cSemicolonKeyword_3 = (Keyword)cGroup.eContents().get(3);
		
		//XAssignment:
		//    name = ID '=' expression = ExpressionString';';
		@Override public ParserRule getRule() { return rule; }
		
		//name = ID '=' expression = ExpressionString';'
		public Group getGroup() { return cGroup; }
		
		//name = ID
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_0_0() { return cNameIDTerminalRuleCall_0_0; }
		
		//'='
		public Keyword getEqualsSignKeyword_1() { return cEqualsSignKeyword_1; }
		
		//expression = ExpressionString
		public Assignment getExpressionAssignment_2() { return cExpressionAssignment_2; }
		
		//ExpressionString
		public RuleCall getExpressionExpressionStringParserRuleCall_2_0() { return cExpressionExpressionStringParserRuleCall_2_0; }
		
		//';'
		public Keyword getSemicolonKeyword_3() { return cSemicolonKeyword_3; }
	}
	public class ExpressionStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.ExpressionString");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cIDTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final Keyword cLeftSquareBracketKeyword_1 = (Keyword)cAlternatives.eContents().get(1);
		private final Keyword cRightSquareBracketKeyword_2 = (Keyword)cAlternatives.eContents().get(2);
		private final Keyword cHyphenMinusKeyword_3 = (Keyword)cAlternatives.eContents().get(3);
		private final Keyword cCommaKeyword_4 = (Keyword)cAlternatives.eContents().get(4);
		private final RuleCall cINTTerminalRuleCall_5 = (RuleCall)cAlternatives.eContents().get(5);
		private final RuleCall cDOUBLETerminalRuleCall_6 = (RuleCall)cAlternatives.eContents().get(6);
		
		//ExpressionString: (ID|'['|']'|'-'|','|INT|DOUBLE)*;
		@Override public ParserRule getRule() { return rule; }
		
		//(ID|'['|']'|'-'|','|INT|DOUBLE)*
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_0() { return cIDTerminalRuleCall_0; }
		
		//'['
		public Keyword getLeftSquareBracketKeyword_1() { return cLeftSquareBracketKeyword_1; }
		
		//']'
		public Keyword getRightSquareBracketKeyword_2() { return cRightSquareBracketKeyword_2; }
		
		//'-'
		public Keyword getHyphenMinusKeyword_3() { return cHyphenMinusKeyword_3; }
		
		//','
		public Keyword getCommaKeyword_4() { return cCommaKeyword_4; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_5() { return cINTTerminalRuleCall_5; }
		
		//DOUBLE
		public RuleCall getDOUBLETerminalRuleCall_6() { return cDOUBLETerminalRuleCall_6; }
	}
	public class ValueElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.Value");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Assignment cStrAssignment_0 = (Assignment)cAlternatives.eContents().get(0);
		private final RuleCall cStrSTRINGTerminalRuleCall_0_0 = (RuleCall)cStrAssignment_0.eContents().get(0);
		private final Assignment cIvalAssignment_1 = (Assignment)cAlternatives.eContents().get(1);
		private final RuleCall cIvalINTTerminalRuleCall_1_0 = (RuleCall)cIvalAssignment_1.eContents().get(0);
		private final Assignment cDvalAssignment_2 = (Assignment)cAlternatives.eContents().get(2);
		private final RuleCall cDvalDOUBLETerminalRuleCall_2_0 = (RuleCall)cDvalAssignment_2.eContents().get(0);
		
		//Value:
		//    (str = STRING) |
		//    (ival = INT) |
		//    (dval = DOUBLE)
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//(str = STRING) |
		//(ival = INT) |
		//(dval = DOUBLE)
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//(str = STRING)
		public Assignment getStrAssignment_0() { return cStrAssignment_0; }
		
		//STRING
		public RuleCall getStrSTRINGTerminalRuleCall_0_0() { return cStrSTRINGTerminalRuleCall_0_0; }
		
		//(ival = INT)
		public Assignment getIvalAssignment_1() { return cIvalAssignment_1; }
		
		//INT
		public RuleCall getIvalINTTerminalRuleCall_1_0() { return cIvalINTTerminalRuleCall_1_0; }
		
		//(dval = DOUBLE)
		public Assignment getDvalAssignment_2() { return cDvalAssignment_2; }
		
		//DOUBLE
		public RuleCall getDvalDOUBLETerminalRuleCall_2_0() { return cDvalDOUBLETerminalRuleCall_2_0; }
	}
	public class XEnumerationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.XEnumeration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cEnumerationKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cLiteralsAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cLiteralsXEnumLiteralParserRuleCall_3_0 = (RuleCall)cLiteralsAssignment_3.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_4 = (Keyword)cGroup.eContents().get(4);
		
		//XEnumeration:
		//    'Enumeration' name = ID '{'
		//        (literals += XEnumLiteral)*
		//    '}'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'Enumeration' name = ID '{'
		//    (literals += XEnumLiteral)*
		//'}'
		public Group getGroup() { return cGroup; }
		
		//'Enumeration'
		public Keyword getEnumerationKeyword_0() { return cEnumerationKeyword_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//(literals += XEnumLiteral)*
		public Assignment getLiteralsAssignment_3() { return cLiteralsAssignment_3; }
		
		//XEnumLiteral
		public RuleCall getLiteralsXEnumLiteralParserRuleCall_3_0() { return cLiteralsXEnumLiteralParserRuleCall_3_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_4() { return cRightCurlyBracketKeyword_4; }
	}
	public class XEnumLiteralElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.XEnumLiteral");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameIDTerminalRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cEqualsSignKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Assignment cValueAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final RuleCall cValueValueParserRuleCall_1_1_0 = (RuleCall)cValueAssignment_1_1.eContents().get(0);
		private final Assignment cCommentAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cCommentVSL_COMMENTTerminalRuleCall_2_0 = (RuleCall)cCommentAssignment_2.eContents().get(0);
		
		//XEnumLiteral:
		//    name=ID
		//    ('=' value = Value)?
		//    (comment = VSL_COMMENT)?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//name=ID
		//('=' value = Value)?
		//(comment = VSL_COMMENT)?
		public Group getGroup() { return cGroup; }
		
		//name=ID
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_0_0() { return cNameIDTerminalRuleCall_0_0; }
		
		//('=' value = Value)?
		public Group getGroup_1() { return cGroup_1; }
		
		//'='
		public Keyword getEqualsSignKeyword_1_0() { return cEqualsSignKeyword_1_0; }
		
		//value = Value
		public Assignment getValueAssignment_1_1() { return cValueAssignment_1_1; }
		
		//Value
		public RuleCall getValueValueParserRuleCall_1_1_0() { return cValueValueParserRuleCall_1_1_0; }
		
		//(comment = VSL_COMMENT)?
		public Assignment getCommentAssignment_2() { return cCommentAssignment_2; }
		
		//VSL_COMMENT
		public RuleCall getCommentVSL_COMMENTTerminalRuleCall_2_0() { return cCommentVSL_COMMENTTerminalRuleCall_2_0; }
	}
	
	
	private final ModelElements pModel;
	private final XDataTypeElements pXDataType;
	private final DTKeyElements pDTKey;
	private final TerminalRule tVSL_COMMENT;
	private final PropertyElements pProperty;
	private final XAssignmentElements pXAssignment;
	private final ExpressionStringElements pExpressionString;
	private final ValueElements pValue;
	private final TerminalRule tDOUBLE;
	private final XEnumerationElements pXEnumeration;
	private final XEnumLiteralElements pXEnumLiteral;
	
	private final Grammar grammar;
	
	private final UmlCommonGrammarAccess gaUmlCommon;
	
	private final CommonGrammarAccess gaCommon;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public DTMLGrammarAccess(GrammarProvider grammarProvider,
			UmlCommonGrammarAccess gaUmlCommon,
			CommonGrammarAccess gaCommon,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaUmlCommon = gaUmlCommon;
		this.gaCommon = gaCommon;
		this.gaTerminals = gaTerminals;
		this.pModel = new ModelElements();
		this.pXDataType = new XDataTypeElements();
		this.pDTKey = new DTKeyElements();
		this.tVSL_COMMENT = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.VSL_COMMENT");
		this.pProperty = new PropertyElements();
		this.pXAssignment = new XAssignmentElements();
		this.pExpressionString = new ExpressionStringElements();
		this.pValue = new ValueElements();
		this.tDOUBLE = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.eclipse.papyrus.robotics.xtext.datatypes.DTML.DOUBLE");
		this.pXEnumeration = new XEnumerationElements();
		this.pXEnumLiteral = new XEnumLiteralElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("org.eclipse.papyrus.robotics.xtext.datatypes.DTML".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public UmlCommonGrammarAccess getUmlCommonGrammarAccess() {
		return gaUmlCommon;
	}
	
	public CommonGrammarAccess getCommonGrammarAccess() {
		return gaCommon;
	}
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Model:
	//    XDataType | XAssignment | XEnumeration
	//;
	public ModelElements getModelAccess() {
		return pModel;
	}
	
	public ParserRule getModelRule() {
		return getModelAccess().getRule();
	}
	
	//XDataType:
	//    DTKey name = ID '{'
	//        (attributes += Property)*
	//    '}'
	//;
	public XDataTypeElements getXDataTypeAccess() {
		return pXDataType;
	}
	
	public ParserRule getXDataTypeRule() {
		return getXDataTypeAccess().getRule();
	}
	
	//DTKey:
	//    'DataType' | 'CommObject'
	//;
	public DTKeyElements getDTKeyAccess() {
		return pDTKey;
	}
	
	public ParserRule getDTKeyRule() {
		return getDTKeyAccess().getRule();
	}
	
	//// visible copy of the SL comment (documentation not clear about how to access comments)
	//// TODO: causes error during generation - which can apparently be ignored.
	//terminal VSL_COMMENT : '//' !('\n'|'\r')* ('\r'? '\n')?;
	public TerminalRule getVSL_COMMENTRule() {
		return tVSL_COMMENT;
	}
	
	//Property:
	//    'attribute' name=ID (':' (type=TypeRule | typeUndefined?="<Undefined>"))?
	//    (multiplicity = MultiplicityRule)?
	//    ('=' value = Value)?
	//    (comment = VSL_COMMENT)?
	//;
	public PropertyElements getPropertyAccess() {
		return pProperty;
	}
	
	public ParserRule getPropertyRule() {
		return getPropertyAccess().getRule();
	}
	
	//XAssignment:
	//    name = ID '=' expression = ExpressionString';';
	public XAssignmentElements getXAssignmentAccess() {
		return pXAssignment;
	}
	
	public ParserRule getXAssignmentRule() {
		return getXAssignmentAccess().getRule();
	}
	
	//ExpressionString: (ID|'['|']'|'-'|','|INT|DOUBLE)*;
	public ExpressionStringElements getExpressionStringAccess() {
		return pExpressionString;
	}
	
	public ParserRule getExpressionStringRule() {
		return getExpressionStringAccess().getRule();
	}
	
	//Value:
	//    (str = STRING) |
	//    (ival = INT) |
	//    (dval = DOUBLE)
	//;
	public ValueElements getValueAccess() {
		return pValue;
	}
	
	public ParserRule getValueRule() {
		return getValueAccess().getRule();
	}
	
	//terminal DOUBLE returns ecore::EDouble:
	//    ('0'..'9')+ '.' ('0'..'9')+
	//;
	public TerminalRule getDOUBLERule() {
		return tDOUBLE;
	}
	
	//XEnumeration:
	//    'Enumeration' name = ID '{'
	//        (literals += XEnumLiteral)*
	//    '}'
	//;
	public XEnumerationElements getXEnumerationAccess() {
		return pXEnumeration;
	}
	
	public ParserRule getXEnumerationRule() {
		return getXEnumerationAccess().getRule();
	}
	
	//XEnumLiteral:
	//    name=ID
	//    ('=' value = Value)?
	//    (comment = VSL_COMMENT)?
	//;
	public XEnumLiteralElements getXEnumLiteralAccess() {
		return pXEnumLiteral;
	}
	
	public ParserRule getXEnumLiteralRule() {
		return getXEnumLiteralAccess().getRule();
	}
	
	//QualifiedName :
	//    path=[uml::Namespace]'::' (remaining=QualifiedName)? ;
	public UmlCommonGrammarAccess.QualifiedNameElements getQualifiedNameAccess() {
		return gaUmlCommon.getQualifiedNameAccess();
	}
	
	public ParserRule getQualifiedNameRule() {
		return getQualifiedNameAccess().getRule();
	}
	
	//TypeRule :
	//    (path=QualifiedName)? type=[uml::Type] ;
	public UmlCommonGrammarAccess.TypeRuleElements getTypeRuleAccess() {
		return gaUmlCommon.getTypeRuleAccess();
	}
	
	public ParserRule getTypeRuleRule() {
		return getTypeRuleAccess().getRule();
	}
	
	//enum VisibilityKind:
	//    public = "+"
	//    | private = "-"
	//    | protected = "#"
	//    | package = "~" ;
	public UmlCommonGrammarAccess.VisibilityKindElements getVisibilityKindAccess() {
		return gaUmlCommon.getVisibilityKindAccess();
	}
	
	public EnumRule getVisibilityKindRule() {
		return getVisibilityKindAccess().getRule();
	}
	
	//MultiplicityRule:
	//    "[" bounds+=BoundSpecification ('..' bounds+=BoundSpecification)? "]" ;
	public UmlCommonGrammarAccess.MultiplicityRuleElements getMultiplicityRuleAccess() {
		return gaUmlCommon.getMultiplicityRuleAccess();
	}
	
	public ParserRule getMultiplicityRuleRule() {
		return getMultiplicityRuleAccess().getRule();
	}
	
	//BoundSpecification:
	//    value = UnlimitedLiteral ;
	public UmlCommonGrammarAccess.BoundSpecificationElements getBoundSpecificationAccess() {
		return gaUmlCommon.getBoundSpecificationAccess();
	}
	
	public ParserRule getBoundSpecificationRule() {
		return getBoundSpecificationAccess().getRule();
	}
	
	//UnlimitedLiteral returns ecore::EString: INT | "*" ;
	public UmlCommonGrammarAccess.UnlimitedLiteralElements getUnlimitedLiteralAccess() {
		return gaUmlCommon.getUnlimitedLiteralAccess();
	}
	
	public ParserRule getUnlimitedLiteralRule() {
		return getUnlimitedLiteralAccess().getRule();
	}
	
	//enum Direction:
	//    IN= "in"
	//    |OUT = "out"
	//    |INOUT = "inout"
	//    |RETURN = "return";
	public UmlCommonGrammarAccess.DirectionElements getDirectionAccess() {
		return gaUmlCommon.getDirectionAccess();
	}
	
	public EnumRule getDirectionRule() {
		return getDirectionAccess().getRule();
	}
	
	//terminal ID : ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*  | ('\'' -> '\'')  ;
	public TerminalRule getIDRule() {
		return gaCommon.getIDRule();
	}
	
	//terminal STRING	: '"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'"'|"'"|'\\') | !('\\'|'"') )* '"' ;
	public TerminalRule getSTRINGRule() {
		return gaCommon.getSTRINGRule();
	}
	
	//terminal ML_COMMENT	: '/*' !('@') -> '*/';
	public TerminalRule getML_COMMENTRule() {
		return gaCommon.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT : '//' !('\n'|'\r'|'@')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaCommon.getSL_COMMENTRule();
	}
	
	//terminal INT returns ecore::EInt: ('0'..'9')+;
	public TerminalRule getINTRule() {
		return gaCommon.getINTRule();
	}
	
	//terminal INTEGER_VALUE :
	//    ('0' | '1'..'9' (('_')? '0'..'9')*) | //DECIMAL
	//    (('0b' | '0B') '0'..'1' (('_')? '0'..'1')*) | // BINARY
	//    (('0x'|'0X') ('0'..'9'|'a'..'f'|'A'..'F')  (('_')? ('0'..'9'|'a'..'f'|'A'..'F'))*) | // HEX
	//    ('0' ('_')? '0'..'7' (('_')? '0'..'7')*) // OCT
	//;
	public TerminalRule getINTEGER_VALUERule() {
		return gaCommon.getINTEGER_VALUERule();
	}
	
	//terminal WS         : (' '|'\t'|'\r'|'\n')+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER: .;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
